/* eslint-disable no-unused-vars */
import request from 'supertest'
import app from '../../../src/app'
import * as hash from '../hash'
/* eslint-enable no-unused-vars */
<%
  const api = $.paths[path][method]

  const pathData = _.swagger.generatePathTestData($, api)

  const queryData = _.swagger.generateQueryTestData($, api)
  const hasQueryData = Object.keys(queryData).length > 0

  const bodyData = _.swagger.generateJsonBodyTestData($, api)
  const hasBodyData = Object.keys(bodyData).length > 0

  function generateUrlCode(overwrite = {}, q = "'") {
    let url = path
    for (const key of Object.keys(pathData)) {
      const val = key in overwrite ? overwrite[key] : pathData[key]
      if (typeof val === "function") {
        q = "`"
        url = url.replace(`{${key}}`, "${" + val() + "}")
      } else {
        url = url.replace(`{${key}}`, val)
      }
    }
    return `${q}${url}${q}`
  }

  function generateRequestCode(propIn = undefined, propName = "", propValue = undefined) {
    const name = propName.match(/^[a-zA-Z0-9]+$/) ? propName : `'${propName}'`

    const pathParam = propIn === "path" ? {[propName]: propValue} : {}

    const queryParam = propIn === "query" ?
      `{ ${name}: ${include("../__common/value/index.ejs", {value: propValue, option: {toStr: true}})} }` : ""

    const bodyParam = propIn === "body" ?
      `{ ${name}: ${include("../__common/value/index.ejs", {value: propValue, option: {}})} }` : ""

    let code = `request(app).${method}(${generateUrlCode(pathParam)}`

    if (hasQueryData) {
      code += ` + query(${queryParam})`
    }
    code += ")"

    if (hasBodyData) {
      code += `.send(body(${bodyParam}))`
    }

    return code
  }

-%>

<% if (hasQueryData) { -%>
const query = (data: {[keyof: string]: string | undefined} = {}) => {
  return '?' + (new URLSearchParams(hash.overwrite(<%-
    _.code.addIndent(
      include("../__common/value/index.ejs", {value: queryData, option: {toStr: true}}),
      { indentStr: '  ', nonIndentFirstLine: true, nonIndentEmptyLine: true }
    )
  %>, data))).toString()
}
<% } -%>
<% if (hasBodyData) { -%>
const body = (data: {[keyof: string]: any} = {}) => {
  return hash.overwrite(<%-
    _.code.addIndent(
      include("../__common/value/index.ejs", {value: bodyData, option: {}}),
      { indentStr: '  ', nonIndentFirstLine: true, nonIndentEmptyLine: true }
    )
  %>, data)
}

<% } -%>
<% for (const parameter of api.parameters || []) {
    const schema = parameter.schema.$ref ? _.swagger.resolveRef($, parameter.schema.$ref) : parameter.schema
-%>
<%-
  include("./schema-validate-tests.ejs", {
    propIn: parameter.in,
    propRequired: !!parameter.required, // 未定義の場合はfalseと解釈する
    propName: parameter.name ,
    schema,
    generateRequestCode
  })
-%>
<% } -%>
describe('body validation', () => {
  it('body is invalid json', async () => {
    let response

    // Success
    response = await <%- generateRequestCode() %>
    expect(response.status).toBe(200)

    // body is not object)
    response = await request(app).post('/users').set('content-type', 'application/json').send('1')
    expect(response.status).toBe(400)
    expect(response.body).toEqual({ message: 'Invalid JSON' })
  })
})
<%
const jsonBody = api.requestBody && api.requestBody.content && api.requestBody.content["application/json"]
if (jsonBody !== undefined) {
  const flatSchema = _.swagger.flatSchema($, jsonBody.schema)
  for (const schemaData of flatSchema) {
    if (schemaData.path === "") {
      // supertest npm を使ってテストした場合、sendメソッドにオブジェクト以外を渡すと'content-type'が'application/x-www-form-urlencoded'で送信される。
      // expressは、'application/json'以外でリクエストを受け取ると、bodyを空オブジェクトとして解釈してしまうので、明示的にsetメソッドで'content-type'を指定する必要がある。
      // また、'application/json'が指定されていて、bodyがオブジェクトとして解釈できない場合、400レスポンスが返される
      continue
    }
    %><%- include("./schema-validate-tests.ejs", {
      propIn: "body",
      propRequired: schemaData.path.match(/\.{n}$/) ?
        undefined : // 配列の要素の場合はJsonの仕様上、undefind(要素なし)を表現できない
        !!schemaData.required, // 未定義の場合はfalseと解釈する
      propName: schemaData.path,
      schema: schemaData.schema,
      generateRequestCode
    }) %><%
  }
}
-%>
